﻿Imports Microsoft.Office.Core
Imports Microsoft.Office.Interop.Excel
Imports System.IO
Imports Microsoft.Office.Interop

Public Class Form1

   Private Sub btnLoadWithSpire_Click(sender As Object, e As EventArgs) Handles btnLoadWithSpire.Click
      Dim wb = New Spire.Xls.Workbook
      wb.LoadFromFile(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "VLOOKUP_by_date_template.xlsx"))

      Dim values(168, 0) As Object
      For i = 0 To 168
         Dim x = #10/17/2024#.AddHours(i)
         values(i, 0) = x
      Next

      wb.Worksheets("Report").InsertArray(values, 3, 10)
      wb.Worksheets("Report")(3, 10, 171, 10).NumberFormat = "yyyy-MM-dd HH:mm"

      wb.CalculateAllValue()
      Dim savePrompt As New SaveFileDialog With {.Filter = "Excel Workbook (*.xlsx)|*.xlsx", .FileName = "VLOOKUP_by_date_Spire.xlsx", .DefaultExt = "xlsx"}
      If savePrompt.ShowDialog = DialogResult.OK Then
         wb.SaveToFile(savePrompt.FileName)
      End If
   End Sub

   Private Sub btnLoadWithInterop_Click(sender As Object, e As EventArgs) Handles btnLoadWithInterop.Click
      Dim excel As New Excel.Application
      Dim workbooks As Excel.Workbooks = Nothing
      Dim wb As Excel.Workbook = Nothing

      Try
         workbooks = excel.Workbooks
         wb = workbooks.Open(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "VLOOKUP_by_date_template.xlsx"), , True)

         Dim values(168, 0) As Object
         For i = 0 To 168
            Dim x = #10/17/2024#.AddHours(i)
            values(i, 0) = x
         Next

         With CType(wb.Worksheets("Report"), Excel.Worksheet)
            .Range("J3", "J171").Value = values
            .Range("J3", "J171").NumberFormat = "yyyy-MM-dd HH:mm"
         End With
         wb.ForceFullCalculation = True

         Dim savePrompt As New SaveFileDialog With {.Filter = "Excel Workbook (*.xlsx)|*.xlsx", .FileName = "VLOOKUP_by_date_interop.xlsx", .DefaultExt = "xlsx"}
         If savePrompt.ShowDialog = DialogResult.OK Then
            wb.SaveAs(savePrompt.FileName)
         End If

      Catch ex As Exception
         MessageBox.Show(ex.ToString)

      Finally
         If wb IsNot Nothing Then
            wb.Close(False)
            wb = Nothing
         End If

         excel.Quit()

         GC.Collect()
         GC.WaitForPendingFinalizers()
      End Try
   End Sub

End Class
